Description

Related issues:

Related to Conversion Tools - Bug #3353: lexer num_literal should support hex... Closed

History

#1 - 10/11/2017 10:23 AM - Greg Shah

Submitted by Neil in a forum post:

The following code compiles and executes in 10.2B08:

    CREATE BROWSE vhBrowse IN WIDGET-POOL "ERRORS-POOL" NO-ERROR

        ASSIGN

            FRAME = FRAME frCheckErrors:HANDLE

            QUERY = QUERY qrQuery:HANDLE

            TITLE = ?

            COL   = 2

            ROW   = 2

            WIDTH = 75

            DOWN  = 11

            VISIBLE = TRUE

            SENSITIVE = TRUE

            COLUMN-SCROLLING = FALSE

            SEPARATORS = TRUE.

 

During parsing, this code throws the following errors:

     [java] Warning: lookup of query '=' failed at line 2274 column 27

     [java] line 2271:65: unexpected token: NO-ERROR

     [java]     at com.goldencode.p2j.uast.ProgressParser.create_browse_stmt(ProgressParser.java:25269)

     [java]     at com.goldencode.p2j.uast.ProgressParser.stmt_list(ProgressParser.java:23788)

     [java]     at com.goldencode.p2j.uast.ProgressParser.statement(ProgressParser.java:6087)

 

To correct the code for valid parsing, the following changes are required:

    

    DEFINE VARIABLE qh AS HANDLE NO-UNDO.

    ASSIGN qh = QUERY qrQuery:HANDLE.

    CREATE BROWSE vhBrowse IN WIDGET-POOL "ERRORS-POOL" /*NO-ERROR*/

        ASSIGN

            FRAME = FRAME frCheckErrors:HANDLE

    /*        QUERY = QUERY qrQuery:HANDLE*/

            QUERY = qh

            TITLE = ?

            COL   = 2
            ROW   = 2

            WIDTH = 75

            DOWN  = 11

            VISIBLE = TRUE

            SENSITIVE = TRUE

            COLUMN-SCROLLING = FALSE

            SEPARATORS = TRUE.

#2 - 10/18/2017 02:08 PM - Greg Shah

My tests show the core issue here is the presence of NO-ERROR which is not a documented option for CREATE BROWSE, but evidently it works

fine.  I've added this option in to the create_browse_stmt rule in progress.g and the following testcase now works:

def temp-table tt field num as int.

def query qrQuery for tt.

def var vhBrowse as handle.

def frame fr tt. 

CREATE BROWSE vhBrowse IN WIDGET-POOL "ERRORS-POOL" NO-ERROR

        ASSIGN

            FRAME = FRAME fr:HANDLE

            QUERY = QUERY qrQuery:HANDLE

            TITLE = ?

            COL   = 2

            ROW   = 2

            WIDTH = 75

            DOWN  = 11

            VISIBLE = TRUE

            SENSITIVE = TRUE

            COLUMN-SCROLLING = FALSE

            SEPARATORS = TRUE.

 

This code fully converts and compiles.

The fix is included in revision 11181 of branch 3353a.

05/15/2024 2/3



#3 - 10/18/2017 02:08 PM - Greg Shah

- Related to Bug #3353: lexer num_literal should support hexadecimal literals added

#4 - 10/19/2017 11:07 AM - Greg Shah

- Status changed from New to Test

- % Done changed from 0 to 100

- Assignee set to Greg Shah

#5 - 10/30/2017 09:43 PM - Greg Shah

Branch 3353a was merged to trunk as revision 11187.  It will soon be available publicly as FWD v3.2.

#6 - 08/21/2018 01:02 PM - Greg Shah

- Status changed from Test to Closed

FWD v3.2.0 has been released. This issue is being closed accordingly.
